with Ada.Exceptions; use Ada.Exceptions;
with Ada.Text_IO;    use Ada.Text_IO;
with Central_Server; use Central_Server;

package body Client_Agents is

   task body Agent is

   begin
      loop
         select
            accept Process (x : Pix_Range_x) do
               Server.Compute
                 (Job => (Origin     => (Re => Min_x * Resolution * Real (x),
                                         Im => Min_y * Resolution),
                          Resolution => Resolution),
                  Diverge_Column => Mandelbrot_Set (x));
            end Process;
         or
            terminate;
         end select;
      end loop;
   exception
      when E : others => Put_Line (Exception_Information (E));
   end Agent;

end Client_Agents;
